<?php
namespace Drupal\cmrf_call_report\Plugin\views\filter;

use Drupal\Core\Form\FormStateInterface;
use Drupal\views\Plugin\views\filter\FilterPluginBase;

/**
 * Exposes call report status to the views module
 *
 * @ViewsFilter("cmrf_call_report_json_search")
 */

class CMRFJsonSearch extends FilterPluginBase {

  /**
   * Exposed filter options.
   *
   * @var bool
   */
  protected $alwaysMultiple = TRUE;

  /**
   * @param $form
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   *
   * @return void
   */
  protected function valueForm(&$form, FormStateInterface $form_state) {

    $form['value'] = [
        '#type' => 'textfield',
        '#title' => $this->t('Entity.Action'),
        '#size' => '25',
        '#default_value' => $this->value,
        '#description' => $this->t('Examples: Contact or Contact.get'),
    ];
  }

  /**
   * @return void
   */
  public function query() {
    $this->ensureMyTable();
    if(str_contains($this->value,'.')){
      $valueParts = explode('.',$this->value);
      $entity = $valueParts[0];
      $action = $valueParts[1];
      $expression = "JSON_CONTAINS(".$this->tableAlias.".".$this->realField.",'\"".$action."\"','$.action')";
      $expression .= " AND ";
    } else {
      $expression = "";
      $entity = $this->value;
    }
    $expression .= "JSON_CONTAINS(".$this->tableAlias.".".$this->realField.",'\"".$entity."\"','$.entity')";
    $this->query->addWhereExpression($this->options['group'], $expression);
  }

  public function adminSummary() {
    return $this->value;
  }

}
